LeetCode 56 合并区间

本题中可以学到的比较重要的方法
lambda表达式定义自定义比较器Comparator
复制代码
Arrays.sort(intervals,(v0,v1)->{
            return v0[0] - v1[0];
            });

(附 : 这种形式也适合于优先队列创建时的自定义比较器定义)

比如:

PriorityQueue<Integer> minTop = new PriorityQueue<>(k , (Integer a,Integer b ) - > { return a - b ;

});

当然了,本身优先队列里的对象如果是包装数据类型的话,就是升序的,这里只是举个例子。

如果需要根据比较的元素来倒序排序,只需要return b - a

Arrays.copyOf

我们定义的res的长度是以intervals的长度来的,但是仅限全部区间不合并的情况下,这个长度才是正确的,否则一定会出现0,0的元素,所以我们要用Index的长度来限制返回的数组长度。这时候需要用copyOf的方法来快捷切割长度,并复制整个数组。

(index + 1)的原因是,index为0时,代表数组中有一个元素,长度总是比index大一个单位。

思路

先看什么时候不合并吧,首先第一个区间入队的时候,肯定不合并。然后如果下一个区间的首部位置大于了现存的最后一个区间的尾部位置,那肯定也合并不了。

如果发现下一个区间的首部位置小于了 现存的最后一个区间的尾部位置,说明两个区间发生了重叠,必然可以合并,合并后,首部不变,尾部变为尾部位置数值较大的那个区间的尾部。

复制代码
class Solution {
    public int[][] merge(int[][] intervals) {
        Arrays.sort(intervals,(v0,v1)->{
            return v0[0] - v1[0];
            });
        int[][] res = new int[intervals.length][2];
        int index = -1;
        //定义res的index
        for(int[] interval : intervals){
            if(index == -1 || interval[0] > res[index][1]){
                res[++index] = interval;
            }
            else{
                res[index][1] = Math.max(res[index][1],interval[1]);
            }
        }
        return Arrays.copyOf(res,index+1);
    }
}
相关推荐
yi0116 小时前
LeetCode 219:存在重复元素 II——哈希表记录“最近一次出现的位置”
数据结构·人工智能·笔记·python·算法·leetcode·哈希表
灯澜忆梦8 小时前
【面向对象编程C++】| 基础语法
java·c++·算法
小蒋观天下9 小时前
专项方案:大场景港口AI安防、多干扰环境下的算法调优与落地实操
人工智能·深度学习·算法·安全·机器学习·计算机视觉·ai大模型
Evand J9 小时前
【电机滤波例程5】渐消因子自适应扩展卡尔曼滤波(EKF),MATLAB。PMSM负载突变下的状态估计。附下载链接
算法·matlab
H.莓飛9 小时前
【数据结构】二叉树_OJ题
linux·开发语言·数据结构·算法
好想像大佬一样能够ak所有10 小时前
Leetcode35.搜索插入位置
数据结构·算法·leetcode
aqiu11111110 小时前
【C++算法打怪专栏】LeetCode 165. 比较版本号(双指针与字符串流法)
c++·算法·leetcode
黄金龙PLUS10 小时前
如何基于置换算法来设计对称加密算法
算法·网络安全·密码学·哈希算法·同态加密
不会就选b10 小时前
算法日常・每日刷题--<动态规划>14
算法
赛博守夜人10 小时前
跨境业务与出海合规之九:海外买量投放与营销虚假流量(Ad Fraud):跨国机房群控与归因欺诈识别算法
算法·安全